<form (ngSubmit)="submit()" [formGroup]="userForm">
    <div class="form">
        <mat-form-field>
            <input matInput type="text" id="username"
                class="form-control" placeholder="Username"
                [formControl]="userForm.get('username')">
            <mat-error class="field-error" *ngIf="userForm.get('username').hasError('required')">
                required
            </mat-error>
            <mat-error class="field-error" *ngIf="userForm.get('username').hasError('minlength')">
                must contains at least 4 characters.
            </mat-error>
        </mat-form-field>
    </div>
    <div class="form">
        <mat-form-field>
            <input matInput type="password" id="password"
                class="form-control" placeholder="Password"
                [formControl]="userForm.get('password')">
            <mat-error class="field-error" *ngIf="userForm.get('password').hasError('required')">
                required
            </mat-error>
            <mat-error class="field-error" *ngIf="userForm.get('password').hasError('minlength')">
                must contains at least 8 characters. 
            </mat-error>
            <mat-error class="field-error" *ngIf="userForm.get('password').hasError('pattern')">
                must contains at least one lower case, one upper case, one number and a special character.
            </mat-error>
            <mat-error class="field-error" *ngIf="userForm.get('password').hasError('pwdSimple')">
                {{ userForm.get('password').getError('pwdSimple').value }}
            </mat-error>
            <mat-error class="field-error" *ngIf="userForm.get('password').hasError('pwdEqUsername')">
                {{ userForm.get('password').getError('pwdEqUsername').value }}
            </mat-error>
        </mat-form-field>
    </div>
    <div class="form">
        <mat-form-field>
            <mat-label>
                Roles
            </mat-label>
            <mat-select [formControl]="userForm.get('roles')" multiple>
                <mat-option *ngFor="let role of rolesList" [value]="role">
                    {{role}}
                </mat-option>
            </mat-select>
        </mat-form-field>
    </div>
    <button type="submit" class="btn btn-primary" [disabled]="userForm.invalid">
        Create User
    </button>
</form>